# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .paged_meta_response import PagedMetaResponse
from .query_response import QueryResponse


class QueryListResponse(pydantic.BaseModel):
    """
    A response containing paged data
    """

    meta: PagedMetaResponse = pydantic.Field(description="Metadata for the set of data returned")
    data: typing.List[QueryResponse] = pydantic.Field(description="The paginated data")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
