# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .asset_response import AssetResponse


class SimilaritySearchItem(pydantic.BaseModel):
    """
    One similarity search item, with optional group by value and a list of items all matching
    the group by value
    """

    group_by_value: typing.Optional[str] = pydantic.Field(
        alias="groupByValue", description="The value of key that's grouped on"
    )
    items: typing.List[AssetResponse] = pydantic.Field(description="List of assets")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
